/*
 * For a detailed explanation regarding each configuration property and type check, visit:
 * https://jestjs.io/docs/en/configuration.html
 */
import type { JestConfigWithTsJest } from 'ts-jest'

export default {
  preset: 'ts-jest',
  testEnvironment: 'node',
  testTimeout: 20000,
  collectCoverage: true,
  transformIgnorePatterns: [
    "<rootDir>/node_modules/(?!(axios|qs))/",
    "\\.pnp\\.[^\\/]+$"
  ],
  coverageReporters: [
    "json-summary",
    "text",
    "lcov"
  ],
  setupFilesAfterEnv: [
    './tests/jest-setup.ts'
  ]
} as JestConfigWithTsJest
