"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.execCanceler = exports.clearCancelerByHash = exports.addRequestCanceler = exports.generateRequestHash = void 0;
/**
 * 取消相同URL和method的上一个未结束请求，主要目的是防止页面切换时串数据，比如tab切换
 * 且只针对get请求
 */
var utils_1 = require("./utils");
Object.defineProperty(exports, "generateRequestHash", { enumerable: true, get: function () { return utils_1.generateRequestHash; } });
var cancellerCache = {};
function addRequestCanceler(url, hash, cancelFn) {
    var urlCache = cancellerCache[url] || {};
    urlCache[hash] = cancelFn;
    cancellerCache[url] = urlCache;
}
exports.addRequestCanceler = addRequestCanceler;
function clearCancelerByHash(url, hash) {
    if (cancellerCache[url] && cancellerCache[url][hash]) {
        Reflect.deleteProperty(cancellerCache[url], hash);
        if (Object.keys(cancellerCache[url]).length === 0) {
            Reflect.deleteProperty(cancellerCache, url);
        }
    }
}
exports.clearCancelerByHash = clearCancelerByHash;
// export function checkIfHasURLCanceler(url: string): boolean {
//   if (!cancellerCache[url]) return false
//   if (Object.keys(cancellerCache[url]).length === 0) return false
//   return true
// }
function execCanceler(url) {
    var cancelers = cancellerCache[url] || {};
    Object.entries(cancelers).forEach(function (_a) {
        var key = _a[0], fn = _a[1];
        fn();
        Reflect.deleteProperty(cancelers, key);
    });
    Reflect.deleteProperty(cancellerCache, url);
}
exports.execCanceler = execCanceler;
// export function getCachedCanceler(hashKey: string) {
//   return cancellerCache[hashKey]
// }
//# sourceMappingURL=cancelLastSameRequest.js.map