"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.hasCalledCancelerRecord = exports.deleteCalledCancellerByHash = exports.addCalledCanceller = exports.cancellerCalled = exports.callCancellerByCancelKey = exports.hasCancelers = exports.deleteCancellerByHash = exports.addCanceller = exports.canceller = exports.generateRequestHash = void 0;
var utils_1 = require("./utils");
Object.defineProperty(exports, "generateRequestHash", { enumerable: true, get: function () { return utils_1.generateRequestHash; } });
// 用来存储取消函数
exports.canceller = {};
function addRecord(record, cancelKey, hash, cancelFn) {
    var cancelObj = record[cancelKey] || {};
    cancelObj[hash] = cancelFn;
    record[cancelKey] = cancelObj;
}
function deleteRecordByHash(record, cancelKey, hash) {
    var cancelObj = record[cancelKey] || {};
    if (!cancelObj[hash])
        return;
    Reflect.deleteProperty(cancelObj, hash);
    if (Object.keys(cancelObj).length === 0) {
        Reflect.deleteProperty(record, cancelKey);
        return;
    }
    record[cancelKey] = cancelObj;
}
function addCanceller(cancelKey, hash, cancelFn) {
    addRecord(exports.canceller, cancelKey, hash, cancelFn);
}
exports.addCanceller = addCanceller;
function deleteCancellerByHash(cancelKey, hash) {
    deleteRecordByHash(exports.canceller, cancelKey, hash);
}
exports.deleteCancellerByHash = deleteCancellerByHash;
function hasCancelers(cancelKey) {
    var cancelObj = exports.canceller[cancelKey];
    if (!cancelObj || Object.keys(cancelObj).length === 0)
        return false;
    return true;
}
exports.hasCancelers = hasCancelers;
function callCancellerByCancelKey(cancelKey) {
    if (!hasCancelers(cancelKey))
        return;
    Object.entries(exports.canceller[cancelKey]).forEach(function (_a) {
        var hash = _a[0], fn = _a[1];
        fn.call();
        deleteCancellerByHash(cancelKey, hash);
    });
}
exports.callCancellerByCancelKey = callCancellerByCancelKey;
// 用来存储已经被调用的取消函数名称
exports.cancellerCalled = {};
function addCalledCanceller(cancelKey, hash, cancelFn) {
    addRecord(exports.cancellerCalled, cancelKey, hash, cancelFn);
}
exports.addCalledCanceller = addCalledCanceller;
function deleteCalledCancellerByHash(cancelKey, hash) {
    deleteRecordByHash(exports.cancellerCalled, cancelKey, hash);
}
exports.deleteCalledCancellerByHash = deleteCalledCancellerByHash;
function hasCalledCancelerRecord(cancelKey, hash) {
    return exports.cancellerCalled[cancelKey] && exports.cancellerCalled[cancelKey][hash];
}
exports.hasCalledCancelerRecord = hasCalledCancelerRecord;
//# sourceMappingURL=canceller.js.map