"use strict";
// 兼容以前的老项目写法
Object.defineProperty(exports, "__esModule", { value: true });
exports.generateCustomMethod = void 0;
var tslib_1 = require("tslib");
var duplicateRequestPrevent_1 = require("./duplicateRequestPrevent");
var helpers_1 = require("./helpers");
var utils_1 = require("./utils");
var methodMap = {
    query: 'GET',
    create: 'POST',
    putWay: 'PUT',
    deletes: 'DELETE',
    patchWay: 'PATCH'
};
var generateCustomMethod = function (ctx, name) { return function (path, config) {
    if (config === void 0) { config = {}; }
    return function (data, expand) { return tslib_1.__awaiter(void 0, void 0, void 0, function () {
        var url, _a, newParams, newData, config1, options, hashKey, request, res;
        return tslib_1.__generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    url = expand ? "".concat(path, "/").concat(expand) : path;
                    if (expand) {
                        // eslint-disable-next-line no-console
                        console.warn("\u4E1A\u52A1\u4EE3\u7801\u4E2D\u62FC\u63A5url\u53D1\u9001\u8BF7\u6C42\u7684\u65B9\u5F0F\u5373\u5C06\u5E9F\u5F03\uFF0C\u8BF7\u4F7F\u7528ajax.".concat(methodMap[name].toLocaleLowerCase(), "\u63A5\u53E3\u66FF\u6362\u3002\u76F8\u5173url\uFF1A").concat(url));
                    }
                    _a = methodMap[name] === 'GET' ? [data, undefined] : [undefined, data], newParams = _a[0], newData = _a[1];
                    config1 = (0, helpers_1.normalizeConfig)(ctx, tslib_1.__assign(tslib_1.__assign({}, config), { url: url, params: newParams, data: newData, method: methodMap[name] }));
                    options = tslib_1.__assign(tslib_1.__assign({}, config1), { custom: tslib_1.__assign(tslib_1.__assign({}, ctx.$options), config1) });
                    hashKey = (0, utils_1.generateRequestHash)(config1);
                    if ((0, duplicateRequestPrevent_1.checkIfHasPendingRequest)(hashKey)) {
                        // 重复，且处于pending状态的请求，复用
                        return [2 /*return*/, (0, duplicateRequestPrevent_1.getCachedRequest)(hashKey)];
                    }
                    request = ctx.request(options);
                    // 缓存请求
                    (0, duplicateRequestPrevent_1.addPendingRequest)(hashKey, request, options.reUseDuration);
                    return [4 /*yield*/, request
                        // 清理缓存的请求
                    ];
                case 1:
                    res = _b.sent();
                    // 清理缓存的请求
                    (0, duplicateRequestPrevent_1.clearPendingRequest)(hashKey);
                    return [2 /*return*/, res];
            }
        });
    }); };
}; };
exports.generateCustomMethod = generateCustomMethod;
function addCompatibleMethods(ctx) {
    ctx.query = (0, exports.generateCustomMethod)(ctx, 'query');
    ctx.create = (0, exports.generateCustomMethod)(ctx, 'create');
    ctx.deletes = (0, exports.generateCustomMethod)(ctx, 'deletes');
    ctx.putWay = (0, exports.generateCustomMethod)(ctx, 'putWay');
    ctx.patchWay = (0, exports.generateCustomMethod)(ctx, 'patchWay');
}
exports.default = addCompatibleMethods;
//# sourceMappingURL=compatibleMethods.js.map