"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getCachedRequest = exports.checkIfHasPendingRequest = exports.clearPendingRequest = exports.addPendingRequest = exports.generateRequestHash = void 0;
var utils_1 = require("./utils");
Object.defineProperty(exports, "generateRequestHash", { enumerable: true, get: function () { return utils_1.generateRequestHash; } });
var pendingRequest = {};
function addPendingRequest(hash, request, timeout) {
    pendingRequest[hash] = request;
    setTimeout(function () {
        clearPendingRequest(hash);
    }, timeout);
}
exports.addPendingRequest = addPendingRequest;
function clearPendingRequest(hash) {
    Reflect.deleteProperty(pendingRequest, hash);
}
exports.clearPendingRequest = clearPendingRequest;
function checkIfHasPendingRequest(hashKey) {
    return Reflect.has(pendingRequest, hashKey);
}
exports.checkIfHasPendingRequest = checkIfHasPendingRequest;
function getCachedRequest(hashKey) {
    return pendingRequest[hashKey];
}
exports.getCachedRequest = getCachedRequest;
//# sourceMappingURL=duplicateRequestPrevent.js.map