export declare function isAbsoluteURL(url: string): boolean;
export declare function combineURLs(baseURL: string, relativeURL?: string): string;
export declare function buildFullPath(baseURL: string, requestedURL: string): string;
type DeepCopy<T> = T extends object ? T extends Array<infer Item> ? DeepCopy<Item>[] : {
    [K in keyof T]: T[K] extends object ? DeepCopy<T[K]> : T[K];
} : T;
export declare function deepCopy<T>(obj: T): DeepCopy<T>;
export declare function getType(obj: any): string;
type NormalizedConfig = {
    params?: Record<string, any>;
    data?: Record<string, any>;
    url?: string;
    baseURL?: string;
    method?: string;
};
/**
 * 获取请求的标识，相同的请求配置有相同的标识
 * @param config 经过标准化的ajax请求配置
 * @returns 该请求的hash key
 */
export declare function generateRequestHash(config: NormalizedConfig): any;
export {};
